/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIIDNService.idl
 */

#ifndef __gen_nsIIDNService_h__
#define __gen_nsIIDNService_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif

/* starting interface:    nsIIDNService */
#define NS_IIDNSERVICE_IID_STR "7b67747e-a8c4-4832-80c7-39ebb0c11f94"

#define NS_IIDNSERVICE_IID \
  {0x7b67747e, 0xa8c4, 0x4832, \
    { 0x80, 0xc7, 0x39, 0xeb, 0xb0, 0xc1, 0x1f, 0x94 }}

/**
 * nsIIDNService interface.
 *
 * IDN (Internationalized Domain Name) support. Provides facilities
 * for turning IDN's from UTF-8 to ACE (ASCII Compatible Encoding).
 *
 * See http://www.ietf.org/html.characters/idn-charter.html
 * or http://www.i-dns.net
 */
class NS_NO_VTABLE nsIIDNService : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IIDNSERVICE_IID)

  /**
     * Prepares the input hostname according to draft-ietf-idn-nameprep-05.txt.
     * Then automatically converts it into an ACE that is most likely to be
     * adopted as the standard.
     *
     * The current input is string, but in the future where everything-is-utf8
     * this may change.  See http://bugzilla.mozilla.org/show_bug.cgi?id=84186
     */
  /* string UTF8ToIDNHostName (in string input); */
  NS_IMETHOD UTF8ToIDNHostName(const char *input, char **_retval) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIIDNSERVICE \
  NS_IMETHOD UTF8ToIDNHostName(const char *input, char **_retval); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIIDNSERVICE(_to) \
  NS_IMETHOD UTF8ToIDNHostName(const char *input, char **_retval) { return _to UTF8ToIDNHostName(input, _retval); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIIDNSERVICE(_to) \
  NS_IMETHOD UTF8ToIDNHostName(const char *input, char **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->UTF8ToIDNHostName(input, _retval); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsIDNService : public nsIIDNService
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIIDNSERVICE

  nsIDNService();
  virtual ~nsIDNService();
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsIDNService, nsIIDNService)

nsIDNService::nsIDNService()
{
  NS_INIT_ISUPPORTS();
  /* member initializers and constructor code */
}

nsIDNService::~nsIDNService()
{
  /* destructor code */
}

/* string UTF8ToIDNHostName (in string input); */
NS_IMETHODIMP nsIDNService::UTF8ToIDNHostName(const char *input, char **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIIDNService_h__ */
