/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIObserver.idl
 */

#ifndef __gen_nsIObserver_h__
#define __gen_nsIObserver_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif

/* starting interface:    nsIObserver */
#define NS_IOBSERVER_IID_STR "db242e01-e4d9-11d2-9dde-000064657374"

#define NS_IOBSERVER_IID \
  {0xdb242e01, 0xe4d9, 0x11d2, \
    { 0x9d, 0xde, 0x00, 0x00, 0x64, 0x65, 0x73, 0x74 }}

/**
 * This interface is implemented by an object that needs
 * to observe an event corresponding to a change in a 
 * topic for a subject.
 */
class NS_NO_VTABLE nsIObserver : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IOBSERVER_IID)

  /**
    * Called if the topic changes for the subject. If you expect 
    * multiple topics/subjects, the impl is responsible for filtering.
    *
    * @param aSubject - the event specific data that has changed.
    * @param aTopic   - indicates the event that has changed.
    * @param aData    - out of band data specific to the topic/
    *                   subject event.
    */
  /* void Observe (in nsISupports aSubject, in wstring aTopic, in wstring aData); */
  NS_IMETHOD Observe(nsISupports *aSubject, const PRUnichar *aTopic, const PRUnichar *aData) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIOBSERVER \
  NS_IMETHOD Observe(nsISupports *aSubject, const PRUnichar *aTopic, const PRUnichar *aData); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIOBSERVER(_to) \
  NS_IMETHOD Observe(nsISupports *aSubject, const PRUnichar *aTopic, const PRUnichar *aData) { return _to Observe(aSubject, aTopic, aData); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIOBSERVER(_to) \
  NS_IMETHOD Observe(nsISupports *aSubject, const PRUnichar *aTopic, const PRUnichar *aData) { return !_to ? NS_ERROR_NULL_POINTER : _to->Observe(aSubject, aTopic, aData); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsObserver : public nsIObserver
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIOBSERVER

  nsObserver();
  virtual ~nsObserver();
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsObserver, nsIObserver)

nsObserver::nsObserver()
{
  NS_INIT_ISUPPORTS();
  /* member initializers and constructor code */
}

nsObserver::~nsObserver()
{
  /* destructor code */
}

/* void Observe (in nsISupports aSubject, in wstring aTopic, in wstring aData); */
NS_IMETHODIMP nsObserver::Observe(nsISupports *aSubject, const PRUnichar *aTopic, const PRUnichar *aData)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif

#define NS_OBSERVER_CONTRACTID "@mozilla.org/xpcom/observer;1"
#define NS_OBSERVER_CLASSNAME "Observer"

#endif /* __gen_nsIObserver_h__ */
