/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIStopwatch.idl
 */

#ifndef __gen_nsIStopwatch_h__
#define __gen_nsIStopwatch_h__


#ifndef __gen_nsIProperties_h__
#include "nsIProperties.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
typedef PRUint32 PRIntervalTime;

class nsIStopwatch; /* forward declaration */

class nsILog; /* forward declaration */


/* starting interface:    nsIStopwatchService */
#define NS_ISTOPWATCHSERVICE_IID_STR "0aeb95e0-be2c-11d3-93bd-000064657374"

#define NS_ISTOPWATCHSERVICE_IID \
  {0x0aeb95e0, 0xbe2c, 0x11d3, \
    { 0x93, 0xbd, 0x00, 0x00, 0x64, 0x65, 0x73, 0x74 }}

class NS_NO_VTABLE nsIStopwatchService : public nsIProperties {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_ISTOPWATCHSERVICE_IID)

  /* nsIStopwatch createStopwatch (in string name, in string countUnits, in boolean perThread); */
  NS_IMETHOD CreateStopwatch(const char *name, const char *countUnits, PRBool perThread, nsIStopwatch **_retval) = 0;

  /* void describeTimings (in nsILog output); */
  NS_IMETHOD DescribeTimings(nsILog *output) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSISTOPWATCHSERVICE \
  NS_IMETHOD CreateStopwatch(const char *name, const char *countUnits, PRBool perThread, nsIStopwatch **_retval); \
  NS_IMETHOD DescribeTimings(nsILog *output); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSISTOPWATCHSERVICE(_to) \
  NS_IMETHOD CreateStopwatch(const char *name, const char *countUnits, PRBool perThread, nsIStopwatch **_retval) { return _to CreateStopwatch(name, countUnits, perThread, _retval); } \
  NS_IMETHOD DescribeTimings(nsILog *output) { return _to DescribeTimings(output); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSISTOPWATCHSERVICE(_to) \
  NS_IMETHOD CreateStopwatch(const char *name, const char *countUnits, PRBool perThread, nsIStopwatch **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->CreateStopwatch(name, countUnits, perThread, _retval); } \
  NS_IMETHOD DescribeTimings(nsILog *output) { return !_to ? NS_ERROR_NULL_POINTER : _to->DescribeTimings(output); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsStopwatchService : public nsIStopwatchService
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSISTOPWATCHSERVICE

  nsStopwatchService();
  virtual ~nsStopwatchService();
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsStopwatchService, nsIStopwatchService)

nsStopwatchService::nsStopwatchService()
{
  NS_INIT_ISUPPORTS();
  /* member initializers and constructor code */
}

nsStopwatchService::~nsStopwatchService()
{
  /* destructor code */
}

/* nsIStopwatch createStopwatch (in string name, in string countUnits, in boolean perThread); */
NS_IMETHODIMP nsStopwatchService::CreateStopwatch(const char *name, const char *countUnits, PRBool perThread, nsIStopwatch **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void describeTimings (in nsILog output); */
NS_IMETHODIMP nsStopwatchService::DescribeTimings(nsILog *output)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif

#define NS_STOPWATCHSERVICE_CID                      \
{ /* 10231fc0-be2c-11d3-93bd-000064657374 */         \
    0x10231fc0,                                      \
    0xbe2c,                                          \
    0x11d3,                                          \
    {0x93, 0xbd, 0x00, 0x00, 0x64, 0x65, 0x73, 0x74} \
}
#define NS_STOPWATCHSERVICE_CONTRACTID        "@mozilla.org/stopwatch-service;1"
#define NS_STOPWATCHSERVICE_CLASSNAME     "Stopwatch Service"

/* starting interface:    nsIStopwatch */
#define NS_ISTOPWATCH_IID_STR "32c89070-b98b-11d3-93bb-00104ba0fd40"

#define NS_ISTOPWATCH_IID \
  {0x32c89070, 0xb98b, 0x11d3, \
    { 0x93, 0xbb, 0x00, 0x10, 0x4b, 0xa0, 0xfd, 0x40 }}

class NS_NO_VTABLE nsIStopwatch : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_ISTOPWATCH_IID)

  /* void init (in string name, in string countUnits, in boolean perThread); */
  NS_IMETHOD Init(const char *name, const char *countUnits, PRBool perThread) = 0;

  /* readonly attribute string name; */
  NS_IMETHOD GetName(char * *aName) = 0;

  /* void start (); */
  NS_IMETHOD Start(void) = 0;

  /* void stop (in double count, out PRIntervalTime elapsed); */
  NS_IMETHOD Stop(double count, PRIntervalTime *elapsed) = 0;

  /* void reset (); */
  NS_IMETHOD Reset(void) = 0;

  /**
     * @param realTimeSamples - units countUnits
     * @param realTimeMean - units milliseconds
     * @param realTimeStdDev - units milliseconds
     */
  /* void getRealTimeStats (out double realTimeSamples, out double realTimeMean, out double realTimeStdDev); */
  NS_IMETHOD GetRealTimeStats(double *realTimeSamples, double *realTimeMean, double *realTimeStdDev) = 0;

  /**
     * @param cpuTimeSamples - units countUnits
     * @param cpuTimeMean - units milliseconds
     * @param cpuTimeStdDev - units milliseconds
     */
  /* void getCPUTimeStats (out double cpuTimeSamples, out double cpuTimeMean, out double cpuTimeStdDev); */
  NS_IMETHOD GetCPUTimeStats(double *cpuTimeSamples, double *cpuTimeMean, double *cpuTimeStdDev) = 0;

  /* void describe (in nsILog log, in string msg); */
  NS_IMETHOD Describe(nsILog *log, const char *msg) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSISTOPWATCH \
  NS_IMETHOD Init(const char *name, const char *countUnits, PRBool perThread); \
  NS_IMETHOD GetName(char * *aName); \
  NS_IMETHOD Start(void); \
  NS_IMETHOD Stop(double count, PRIntervalTime *elapsed); \
  NS_IMETHOD Reset(void); \
  NS_IMETHOD GetRealTimeStats(double *realTimeSamples, double *realTimeMean, double *realTimeStdDev); \
  NS_IMETHOD GetCPUTimeStats(double *cpuTimeSamples, double *cpuTimeMean, double *cpuTimeStdDev); \
  NS_IMETHOD Describe(nsILog *log, const char *msg); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSISTOPWATCH(_to) \
  NS_IMETHOD Init(const char *name, const char *countUnits, PRBool perThread) { return _to Init(name, countUnits, perThread); } \
  NS_IMETHOD GetName(char * *aName) { return _to GetName(aName); } \
  NS_IMETHOD Start(void) { return _to Start(); } \
  NS_IMETHOD Stop(double count, PRIntervalTime *elapsed) { return _to Stop(count, elapsed); } \
  NS_IMETHOD Reset(void) { return _to Reset(); } \
  NS_IMETHOD GetRealTimeStats(double *realTimeSamples, double *realTimeMean, double *realTimeStdDev) { return _to GetRealTimeStats(realTimeSamples, realTimeMean, realTimeStdDev); } \
  NS_IMETHOD GetCPUTimeStats(double *cpuTimeSamples, double *cpuTimeMean, double *cpuTimeStdDev) { return _to GetCPUTimeStats(cpuTimeSamples, cpuTimeMean, cpuTimeStdDev); } \
  NS_IMETHOD Describe(nsILog *log, const char *msg) { return _to Describe(log, msg); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSISTOPWATCH(_to) \
  NS_IMETHOD Init(const char *name, const char *countUnits, PRBool perThread) { return !_to ? NS_ERROR_NULL_POINTER : _to->Init(name, countUnits, perThread); } \
  NS_IMETHOD GetName(char * *aName) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetName(aName); } \
  NS_IMETHOD Start(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->Start(); } \
  NS_IMETHOD Stop(double count, PRIntervalTime *elapsed) { return !_to ? NS_ERROR_NULL_POINTER : _to->Stop(count, elapsed); } \
  NS_IMETHOD Reset(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->Reset(); } \
  NS_IMETHOD GetRealTimeStats(double *realTimeSamples, double *realTimeMean, double *realTimeStdDev) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetRealTimeStats(realTimeSamples, realTimeMean, realTimeStdDev); } \
  NS_IMETHOD GetCPUTimeStats(double *cpuTimeSamples, double *cpuTimeMean, double *cpuTimeStdDev) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetCPUTimeStats(cpuTimeSamples, cpuTimeMean, cpuTimeStdDev); } \
  NS_IMETHOD Describe(nsILog *log, const char *msg) { return !_to ? NS_ERROR_NULL_POINTER : _to->Describe(log, msg); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsStopwatch : public nsIStopwatch
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSISTOPWATCH

  nsStopwatch();
  virtual ~nsStopwatch();
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsStopwatch, nsIStopwatch)

nsStopwatch::nsStopwatch()
{
  NS_INIT_ISUPPORTS();
  /* member initializers and constructor code */
}

nsStopwatch::~nsStopwatch()
{
  /* destructor code */
}

/* void init (in string name, in string countUnits, in boolean perThread); */
NS_IMETHODIMP nsStopwatch::Init(const char *name, const char *countUnits, PRBool perThread)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute string name; */
NS_IMETHODIMP nsStopwatch::GetName(char * *aName)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void start (); */
NS_IMETHODIMP nsStopwatch::Start()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void stop (in double count, out PRIntervalTime elapsed); */
NS_IMETHODIMP nsStopwatch::Stop(double count, PRIntervalTime *elapsed)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void reset (); */
NS_IMETHODIMP nsStopwatch::Reset()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void getRealTimeStats (out double realTimeSamples, out double realTimeMean, out double realTimeStdDev); */
NS_IMETHODIMP nsStopwatch::GetRealTimeStats(double *realTimeSamples, double *realTimeMean, double *realTimeStdDev)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void getCPUTimeStats (out double cpuTimeSamples, out double cpuTimeMean, out double cpuTimeStdDev); */
NS_IMETHODIMP nsStopwatch::GetCPUTimeStats(double *cpuTimeSamples, double *cpuTimeMean, double *cpuTimeStdDev)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void describe (in nsILog log, in string msg); */
NS_IMETHODIMP nsStopwatch::Describe(nsILog *log, const char *msg)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif

////////////////////////////////////////////////////////////////////////////////
#define NS_STOPWATCH_CID                             \
{ /* 46fa0bc0-b98b-11d3-93bb-00104ba0fd40 */         \
    0x46fa0bc0,                                      \
    0xb98b,                                          \
    0x11d3,                                          \
    {0x93, 0xbb, 0x00, 0x10, 0x4b, 0xa0, 0xfd, 0x40} \
}
#define NS_STOPWATCH_CONTRACTID        "@mozilla.org/stopwatch;1"
#define NS_STOPWATCH_CLASSNAME     "Stopwatch"
////////////////////////////////////////////////////////////////////////////////
#if (defined(DEBUG) || defined(NS_DEBUG)) && !defined(WIN16)
// enable STOPWATCH by default
#define NS_ENABLE_STOPWATCH
#endif
#ifdef NS_DISABLE_STOPWATCH
// override, if you want DEBUG, but *not* STOPWATCH (for some reason)
#undef NS_ENABLE_STOPWATCH
#endif
#ifdef NS_ENABLE_STOPWATCH
#define NS_DECL_STOPWATCH(_name)                nsIStopwatch* _name
#define NS_INIT_STOPWATCH(_stopwatch, _countUnits, _perThread)                   \
    PR_BEGIN_MACRO                                                               \
    if (_stopwatch == nsnull) {                                                  \
        nsresult _rv;                                                            \
        static NS_DEFINE_CID(kStopwatchServiceCID, NS_STOPWATCHSERVICE_CID);     \
        nsCOMPtr<nsIStopwatchService> _serv =                                    \
                 do_GetService(kStopwatchServiceCID, &_rv);                      \
        if (NS_SUCCEEDED(_rv)) {                                                 \
            _rv = _serv->CreateStopwatch(#_stopwatch,  _countUnits, _perThread,  \
                                         &_stopwatch);                           \
            PR_ASSERT(NS_SUCCEEDED(_rv));                                        \
        }                                                                        \
    }                                                                            \
    PR_END_MACRO
#define NS_STOPWATCH_START(_sw)                 ((_sw)->Start())
#define NS_STOPWATCH_STOP(_sw, _cnt, _elapsed)  ((_sw)->Stop(_cnt, _elapsed))
#define NS_STOPWATCH_RESET(_sw)                 ((_sw)->Reset())
#define NS_STOPWATCH_GETREALTIMESTATS(_sw, _samples, _mean, _sd) \
    ((_sw)->GetRealTimeStats(_samples, _mean, _sd))
#define NS_STOPWATCH_GETCPUTIMESTATS(_sw, _samples, _mean, _sd) \
    ((_sw)->GetCPUTimeStats(_samples, _mean, _sd))
#define NS_STOPWATCH_DESCRIBE(_sw, _log, _msg)  ((_sw)->Describe(_log, _msg))
#else // !NS_ENABLE_STOPWATCH
#define NS_DECL_STOPWATCH(_name)                void _not_used() // something that can be used with extern
#define NS_INIT_STOPWATCH(_stopwatch, _countUnits, _perThread)    NS_OK
#define NS_STOPWATCH_START(_sw)                 NS_OK
#define NS_STOPWATCH_STOP(_sw, _cnt, _elapsed) (*(_elapsed) = 0)
#define NS_STOPWATCH_RESET(_sw)                 NS_OK
#define NS_STOPWATCH_GETREALTIMESTATS(_sw, _samples, _mean, _sd) \
    (*(_samples) = 0, *(_mean) = 0, *(_sd) = 0)
#define NS_STOPWATCH_GETCPUTIMESTATS(_sw, _samples, _mean, _sd) \
    (*(_samples) = 0, *(_mean) = 0, *(_sd) = 0)
#define NS_STOPWATCH_DESCRIBE(_sw, _log, _msg)  NS_OK
#endif // !NS_ENABLE_STOPWATCH
////////////////////////////////////////////////////////////////////////////////

#endif /* __gen_nsIStopwatch_h__ */
